//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Button
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

.m-button {
  @extend .m-button-typo;
  border-radius: var(--m-border-radius);
  outline: 0;
  padding: 16px 32px;
  min-width: 152px;
  display: flex;
  align-items: center;
  justify-content: center;
  transition: 0.3s ease-in-out;
  -webkit-user-select: none;
  -moz-user-select: none;
  -ms-user-select: none;
  user-select: none;
  cursor: pointer;
  ng-miam-icon {
    margin-left: 20px;
    padding: 0;
  }

  &:disabled {
    background-color: var(--m-color-grey06);
    color: var(--m-color-grey03);
    min-height: 42px;

    ng-miam-icon {
      svg {
        fill: var(--m-color-grey03);
      }
    }

    &:hover {
      cursor: default;
      background-color: var(--m-color-grey06);
      color: var(--m-color-grey03);
    }
  }

   &:focus{
    box-shadow: 0px 0px 0px 4px #C1F0EC; // need a variable name 
   }
 
}

@mixin buttonFactory($text-color, $background-color, $hover-background-color, $border-color : transparent) {
  @extend .m-button;
  background-color: $background-color;
  border: 1px solid $border-color;
  color: $text-color;
  ng-miam-icon{
    svg{
      path{
        fill: $text-color;      
      }
    }
  }
  
  &:hover {
    background-color: $hover-background-color ;
  } 
}

.m-button-primary {
  @include buttonFactory( var(--m-color-unpure-white),var(--m-color-primary),var(--m-color-primary-dark));
}

.m-button-secondary {
  @include buttonFactory( var(--m-color-primary), var(--m-color-unpure-white), var(--m-color-primary-light), var(--m-color-primary) );
}

.m-button-link {
  @include buttonFactory( var(--m-color-unpure-white), var(--m-color-primary), var(--m-color-secondary-dark));
}

.m-button-grey {
  @include buttonFactory(var(--m-color-grey03),var(--m-color-unpure-white), var(--m-color-hairlines),var(--m-color-grey03));
}


.m-button-fab {
  @extend .m-button;
  border-radius: var(--m-border-radius-circle);
  outline: 0;
  padding: 8px;
  min-width: unset;
  ng-miam-icon {
    margin-left: 0px;
  }

  &:disabled {
    fill: var(--m-color-grey-text-dark);
    &:hover {
      fill: var(--m-color-grey-text-dark);
    }
  }
}

.m-button-fab-primary {
  @extend .m-button-fab;
  background-color: var(--m-color-primary);
  fill: var(--m-color-primary-text);
  border: 1px solid transparent;
  &:hover {
    border: 1px solid var(--m-color-primary-text);
    path {
      fill: var(--m-color-primary);
    }
    background-color: var(--m-color-primary-text);
  }
}

.m-button-fab-secondary {
  @extend .m-button-fab;
  background-color: var(--m-color-secondary-text);
  fill: var(--m-color-secondary);
  border: 1px solid var(--m-color-secondary);

  &:hover {
    fill: var(--m-color-secondary-text);
    background-color: var(--m-color-secondary);
  }
}

.m-button-fab-grey {
  @extend .m-button-fab;
  @extend .m-button-grey;
  background-color: #fff;
  border: none;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Input
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

.m-input{
  @extend .m-body-typo;
  &> * {
    @extend .m-body-typo;
  }
  display: flex;
  justify-content: space-between;
  align-items: center;
  max-width: 320px;
  min-width: 200px;
  border: 1px solid var(--m-color-grey06);
  border-radius: 5px;
  padding: 8px 16px;
  margin-top:16px ;
  outline: none;

  &:focus-within {
    border: 1px solid var(--m-color-primary);
  }
}

.m-title-text-input{
 input {
   @extend .m-h1-typo;
  }

  label{
    &:not(.miam-text-input__label__top){
      @extend .m-h1-typo;
    }  
  }

  &:focus-within {
    .miam-text-input__label{
      @extend .m-body-typo;
    }
  }
  .miam-text-input{
    max-width: 565px;
   }
  
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///  Card
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

.m-default-card{
  box-shadow: var(--m-shadow-small);
  background-color: var(--m-color-unpure-white);
  padding: 16px;
  border-radius: 8px;
}
